

#include "LedControl.h"

LedControl lc = LedControl(12, 10, 11, 1);



#define buttonPin 2


int buttonState = 0;
bool isLetterA = true;      // Variable to track the current status, i.e. the letter currently displayed (A or M)

void setup() {
  lc.shutdown(0, false);
  lc.setIntensity(0, 8);
  lc.clearDisplay(0);
  pinMode(buttonPin, INPUT);
  Serial.begin(9600);
  writeArduinoOnMatrix(); 
  
}


void fillMatrix() {
  for (int i = 0; i < 8; i++) {
    for (int j = 0; j < 8; j++) {
      lc.setLed(0, j, 7 - i, true);
      delay(50);
    }
  }
}


void clearMatrixEffect() {
  for (int speed = 60; speed > 0; speed -= 15) {
    for (int i = 0; i < 8; i++) {
      lc.setColumn(0, i, 0);
      delay(speed);
    }
    for (int i = 0; i < 8; i++) {
      lc.setColumn(0, i, B11111111);
      delay(speed);
    }
  }
  lc.clearDisplay(0);
}



void displayLetterSmoothly(byte letter[8]) {
  for (int i = 0; i < 8; i++) {
    lc.setColumn(0, 7 - i, letter[i]);
    delay(80);
  }
}



void writeArduinoOnMatrix() {
  byte A[8] = {
    B00011000,
    B00100100,
    B01000010,
    B01000010,
    B01111110,
    B01000010,
    B01000010,
    B01000010};

  byte M[8] = {
    B11000011,
    B11100111,
    B10111101,
    B10011001,
    B10000001,
    B10000001,
    B10000001,
    B10000001};

    

  if (isLetterA) {
    
    // Transition de A à M
    fillMatrix();
    clearMatrixEffect();
    displayLetterSmoothly(A);
    isLetterA = false; 
  } 
  


  
  else {
    // Transition de M à A
    fillMatrix();
    clearMatrixEffect();
    displayLetterSmoothly(M);
    isLetterA = true;
  }



  
}



void loop() {
  
  buttonState = digitalRead(buttonPin);


  if(buttonState == LOW){                     //low --> when the button is pressed
    //Serial.println("Bouton appuyé");
    writeArduinoOnMatrix(); 
      
  }

}
